@page "/ToDoList"
@attribute [Authorize]
@inject TodoService todoService

<PageTitle>ToDo list</PageTitle>

<div class="container mt-5 text-center">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <h1 class="display-4">ToDo List</h1>
            <p class="lead">What should I do before tomorrow</p>
        </div>
    </div>
</div>
@if (todos == null)
{
    <p><em>Loading...</em></p>
}
else
{
    <button class="btn btn-primary float-right mb-3" @onclick="addTodo">Add a new todo</button>

    <table class="table">
        <thead>
            <tr>
                <th class="text-right">Id</th>
                <th class="text-right">Status</th>
                <th class="text-right">Text</th>
                <th class="text-right">Actions</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var todo in todos)
            {
                <tr>
                    <td class="text-right">@todo.Id</td>
                    <td class="text-right"><InputCheckbox @bind-Value="@todo.IsDone" /></td>
                    <td class="text-right">
                        <InputText @bind-Value="todo.Text" />
                    </td>
                    <td class="text-right">
                        <button class="btn btn-success mr-2" @onclick="() => UpdateTodo(todo)">Save</button>
                        <button class="btn btn-danger" @onclick="() => DeleteTodo(todo.Id)">X</button>
                    </td>
                </tr>
            }
        </tbody>
    </table>
}

@code {
    private Todo[]? todos;

    protected override async Task OnInitializedAsync()
    {
        todos = await todoService.GetAllTasks();
    }

    private async Task addTodo()
    {
        if (todos == null) return;
        var newTodo = await todoService.CreateNewTask();
        Console.WriteLine(newTodo.Id);
        var todosList = todos.ToList();
        todosList.Add(newTodo);
        todos = todosList.ToArray();
    }

    private async Task DeleteTodo(int id)
    {
        if (todos == null) return;
        await todoService.Delete(id);
        todos = todos.Where(t => t.Id != id).ToArray();
    }

    private async Task UpdateTodo(Todo todo)
    {
        await todoService.UpdateTodo(todo);
    }
}